######################################################################
# Automatically generated by qmake (2.01a) Sat Mar 17 11:24:10 2012
######################################################################

TEMPLATE = app
TARGET = popart
DEPENDPATH += src src/gui src/networks src/popgen src/seqio src/tree
INCLUDEPATH += src src/networks src/seqio src/popgen src/tree src/gui
DEFINES += NET_QT
CONFIG += qt warn_on release c++98
QT += svg printsupport

# default directory for lp_solve headers
unix:!macx{
  PRELPSOLVEDIR=/usr/include/lpsolve
  PREMARBLEDIR=/usr/include/marble

  exists($$PRELPSOLVEDIR/lp_lib.h){
  DEPENDPATH += $$PRELPSOLVEDIR
  INCLUDEPATH += $$PRELPSOLVEDIR
  } else:exists($$LPSOLVEDIR/lp_lib.h ) {
  DEPENDPATH += $$LPSOLVEDIR
  INCLUDEPATH += $$LPSOLVEDIR
      } else {
  error( "lpsolve headers not found!" )
  }

  exists($$PREMARBLEDIR/MarbleWidget.h){
  DEPENDPATH += $$PREMARBLEDIR
  INCLUDEPATH += $$PREMARBLEDIR
  } else:exists($$MARBLEDIR/MarbleWidget.h ) {
  DEPENDPATH += $$MARBLEDIR
  INCLUDEPATH += $$MARBLEDIR
      } else {
  error( "Marble headers not found!" )
  }

  # This works on Ubuntu 18.04, which links liblpsolve55.a rather than the .so, which is in a subdirectory /usr/lib/lp_solve
  LIBS += -llpsolve55 -lmarblewidget-qt5 -ldl -lcolamd
  #LIBS += -llpsolve55 -lmarblewidget
  #QMAKE_POST_LINK = build_help.sh
}

macx{
  ICON = popart.icns
  INCLUDEPATH += /usr/local/include /usr/local/include/marble
  LIBS += -L/usr/local/lib -llpsolve55 -lmarblewidget-qt5

  RC_FILE = popart.rc
  QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.9
  QMAKE_MAC_SDK = macosx10.9
}

win32{
  INCLUDEPATH += "c:/lpsolve55" "c:/marble/marble"
  LIBS += "c:/lpsolve55/lpsolve55.lib" "c:/marble/libmarblewidget.dll"
  CONFIG += exceptions rtti #static static-libgcc
  RC_FILE = popart.rc

}

# Input
HEADERS += src/gui/AlignmentDelegate.h \
           src/gui/AlignmentModel.h \
           src/gui/AlignmentView.h \
           src/gui/Assistant.h \
           src/gui/BarchartItem.h \
           src/gui/BorderRectItem.h \
           src/gui/CitationDialog.h \
           src/gui/ColourDialog.h \
           src/gui/ColourTheme.h \
           src/gui/EdgeItem.h \
           src/gui/GroupItemDialog.h \
           src/gui/HapnetWindow.h \
           src/gui/HapAppError.h \
           src/gui/HapLayer.h \
           src/gui/HapLocation.h \
           src/gui/LabelItem.h \
           src/gui/LegendItem.h \
           src/gui/MapLegendDialog.h \
           src/gui/MapLegendWidget.h \
           src/gui/MapView.h \
           src/gui/MonospaceMessageBox.h \
           src/gui/MoveCommand.h \
           src/gui/NetworkItem.h \
           src/gui/NetworkLayout.h \
           src/gui/NetworkModel.h \
           src/gui/NetworkScene.h \
           src/gui/NetworkView.h \
           src/gui/SelectionRange.h \
           src/gui/TaxBoxItem.h \
           src/gui/TraitItem.h \
           src/gui/TraitModel.h \
           src/gui/TraitView.h \
           src/gui/VertexItem.h \
           src/gui/XPM.h \
           src/networks/AbstractMSN.h \
           src/networks/AncestralSeqNet.h \
           src/networks/ConcreteHapNet.h \
           src/networks/Edge.h \
           src/networks/Graph.h \
           src/networks/HapNet.h \
           src/networks/IntNJ.h \
           src/networks/MinSpanNet.h \
           src/networks/MedJoinNet.h \
           src/networks/NetworkError.h \
           src/networks/Vertex.h \
           src/networks/ParsimonyNet.h \
           src/networks/TCS.h \
           src/networks/TightSpanWalker.h \
           src/popgen/Statistics.h \
           src/popgen/StatsError.h \
           src/seqio/GeneticCode.h \
           src/seqio/GeoTrait.h \
           src/seqio/NexusParser.h \
           src/seqio/ParserTools.h \
           src/seqio/PhylipParser.h \
           src/seqio/SeqParseError.h \
           src/seqio/SeqParser.h \
           src/seqio/Sequence.h \
           src/seqio/SequenceError.h \
           src/seqio/TableParser.h \
           src/seqio/Trait.h \
           src/tree/ParsimonyNode.h \
           src/tree/ParsimonyTree.h \
           src/tree/SeqNode.h \
           src/tree/SeqTree.h \
           src/tree/Tree.h \
           src/tree/TreeError.h \
           src/tree/TreeNode.h
SOURCES += src/gui/AlignmentDelegate.cpp \
           src/gui/AlignmentModel.cpp \
           src/gui/AlignmentView.cpp \
           src/gui/Assistant.cpp \
           src/gui/BarchartItem.cpp \
           src/gui/BorderRectItem.cpp \
           src/gui/CitationDialog.cpp \
           src/gui/ColourDialog.cpp \
           src/gui/ColourTheme.cpp \
           src/gui/EdgeItem.cpp \
           src/gui/GroupItemDialog.cpp \
           src/gui/HapnetWindow.cpp \
           src/gui/HapApp.cpp \
           src/gui/HapAppError.cpp \
           src/gui/HapLayer.cpp \
           src/gui/HapLocation.cpp \
           src/gui/LabelItem.cpp \
           src/gui/LegendItem.cpp \
           src/gui/MapLegendDialog.cpp \
           src/gui/MapLegendWidget.cpp \
           src/gui/MapView.cpp \
           src/gui/MonospaceMessageBox.cpp \
           src/gui/MoveCommand.cpp \
           src/gui/NetworkItem.cpp \
           src/gui/NetworkLayout.cpp \
           src/gui/NetworkModel.cpp \
           src/gui/NetworkScene.cpp \
           src/gui/NetworkView.cpp \
           src/gui/SelectionRange.cpp \
           src/gui/TaxBoxItem.cpp \
           src/gui/TraitItem.cpp \
           src/gui/TraitModel.cpp \
           src/gui/TraitView.cpp \
           src/gui/VertexItem.cpp \
           src/networks/AbstractMSN.cpp \
           src/networks/AncestralSeqNet.cpp \
           src/networks/ConcreteHapNet.cpp \
           src/networks/Edge.cpp \
           src/networks/Graph.cpp \
           src/networks/HapNet.cpp \
           src/networks/IntNJ.cpp \
           src/networks/MinSpanNet.cpp \
           src/networks/MedJoinNet.cpp \
           src/networks/NetworkError.cpp \
           src/networks/Vertex.cpp \
           src/networks/ParsimonyNet.cpp \
           src/networks/TCS.cpp \
           src/popgen/Statistics.cpp \
           src/popgen/StatsError.cpp \
           src/networks/TightSpanWalker.cpp \
           src/seqio/GeneticCode.cpp \
           src/seqio/GeoTrait.cpp \
           src/seqio/NexusParser.cpp \
           src/seqio/ParserTools.cpp \
           src/seqio/PhylipParser.cpp \
           src/seqio/SeqParseError.cpp \
           src/seqio/SeqParser.cpp \
           src/seqio/Sequence.cpp \
           src/seqio/SequenceError.cpp \
           src/seqio/TableParser.cpp \
           src/seqio/Trait.cpp \
           src/tree/ParsimonyNode.cpp \
           src/tree/ParsimonyTree.cpp \
           src/tree/SeqNode.cpp \
           src/tree/SeqTree.cpp \
           src/tree/Tree.cpp \
           src/tree/TreeError.cpp \
           src/tree/TreeNode.cpp
 
